module     p0_ddbar_emepg_diagramsh5l0
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Z1jet/1.4/Virtual/p
   ! 0_ddbar_emepg/helicity5/diagramsl0.f90
   ! generator: haggies (1.1)
   use p0_ddbar_emepg_color, only: numcs
   use p0_ddbar_emepg_config, only: ki
   implicit none

   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   complex(ki), dimension(numcs), parameter :: zero_col = 0.0_ki

   public :: amplitude

contains
   function     amplitude()
      use p0_ddbar_emepg_model
      use p0_ddbar_emepg_kinematics
      use p0_ddbar_emepg_color
      use p0_ddbar_emepg_config, only: debug_lo_diagrams, &
        & use_sorted_sum
      use p0_ddbar_emepg_accu, only: sorted_sum
      use p0_ddbar_emepg_util, only: inspect_lo_diagram
      implicit none
      complex(ki), dimension(numcs) :: amplitude
      complex(ki), dimension(4,numcs) :: diagrams
      integer :: i
      complex(ki) :: t1
      complex(ki) :: t2
      real(ki) :: t3
      diagrams(:,:) = (0.0_ki, 0.0_ki)
      t3 = es34-(es51+es12)
      t1 = es34+i_*mZ*wZ-mZ*mZ
      t2 = t1*t3*spbk5k2*sqrt2
      diagrams(4, :) = (spak4k5*i_*(4.0_ki)*(es12/t2*gDl*ger*spbk3k1+es51/t2*gDl&
      &*ger*spbk3k1-es34/t2*gDl*ger*spbk3k1)*c1)
      t2 = t3*es34*spbk5k2*sqrt2
      diagrams(3, :) = (spak4k5*i_*(4.0_ki/3.0_ki)*(es12/t2*spbk3k1+es51/t2*spbk&
      &3k1-spbk3k1/(t3*spbk5k2*sqrt2))*c1)
      diagrams(2, :) = (spbk3k1*spbk2k1*spak2k4*spak1k5*i_*ger*gDl*(4.0_ki)/(t1*&
      &es51*spbk5k2*sqrt2)*c1)
      diagrams(1, :) = (spbk3k1*spbk2k1*spak2k4*spak1k5*i_*(4.0_ki/3.0_ki)/(es34&
      &*es51*spbk5k2*sqrt2)*c1)
      if (debug_lo_diagrams) then
         call inspect_lo_diagram(diagrams(1,:), 1, 5, 19)
         call inspect_lo_diagram(diagrams(2,:), 2, 5, 19)
         call inspect_lo_diagram(diagrams(3,:), 3, 5, 19)
         call inspect_lo_diagram(diagrams(4,:), 4, 5, 19)
      end if

      if (use_sorted_sum) then
         do i=1,numcs
            amplitude(i) = sorted_sum(diagrams(:,i))
         end do
      else
         do i=1,numcs
            amplitude(i) = sum(diagrams(:,i))
         end do
      end if
   end function     amplitude
end module p0_ddbar_emepg_diagramsh5l0
