module     p3_uubar_emepg_diagramsh1l0
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Z1jet/1.4/Virtual/p
   ! 3_uubar_emepg/helicity1/diagramsl0.f90
   ! generator: haggies (1.1)
   use p3_uubar_emepg_color, only: numcs
   use p3_uubar_emepg_config, only: ki
   implicit none

   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   complex(ki), dimension(numcs), parameter :: zero_col = 0.0_ki

   public :: amplitude

contains
   function     amplitude()
      use p3_uubar_emepg_model
      use p3_uubar_emepg_kinematics
      use p3_uubar_emepg_color
      use p3_uubar_emepg_config, only: debug_lo_diagrams, &
        & use_sorted_sum
      use p3_uubar_emepg_accu, only: sorted_sum
      use p3_uubar_emepg_util, only: inspect_lo_diagram
      implicit none
      complex(ki), dimension(numcs) :: amplitude
      complex(ki), dimension(4,numcs) :: diagrams
      integer :: i
      complex(ki) :: t1
      real(ki) :: t2
      diagrams(:,:) = (0.0_ki, 0.0_ki)
      t2 = gUl*ger
      t1 = (es34+i_*mZ*wZ-mZ*mZ)*es51
      diagrams(2, :) = (spak2k4*i_*(4.0_ki)*(t2/(t1*spak2k5*sqrt2)*spak1k2*spbk3&
      &k1*spbk5k1-t2/(t1*sqrt2)*spbk5k1*spbk5k3)*c1)
      t2 = es34*es51
      diagrams(1, :) = (spak2k4*i_*(8.0_ki/3.0_ki)*(spbk5k1/(t2*sqrt2)*spbk5k3-s&
      &pak1k2/(t2*spak2k5*sqrt2)*spbk3k1*spbk5k1)*c1)
      if (debug_lo_diagrams) then
         call inspect_lo_diagram(diagrams(1,:), 1, 1, 19)
         call inspect_lo_diagram(diagrams(2,:), 2, 1, 19)
         call inspect_lo_diagram(diagrams(3,:), 3, 1, 19)
         call inspect_lo_diagram(diagrams(4,:), 4, 1, 19)
      end if

      if (use_sorted_sum) then
         do i=1,numcs
            amplitude(i) = sorted_sum(diagrams(:,i))
         end do
      else
         do i=1,numcs
            amplitude(i) = sum(diagrams(:,i))
         end do
      end if
   end function     amplitude
end module p3_uubar_emepg_diagramsh1l0
